let prefs={};

var msgs;
var wid;
var msgCount;
var allValid=false;
var sending=false;
var cardbook;	//0: no cardbook, 1: only cardbook, 2: cardbook and TB
var cardbook_messaging; //true if cardbook implements messaging api
var mLists=new Map;
var origAcctId;
var sendOk=true;
var allowResend=false;
var doneText;

function validate(elem) {
//  const re=/^(?:.*<)?(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9]))\.){3}(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9])|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])>?$/i;
  const re=/^((?:[^<]*<)?(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9]))\.){3}(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9])|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])>?[,]?)+$/i;
  let address=elem.value;
//debug('validate '+address+' list? '+elem.name);
	if (elem.name && address.toLocaleLowerCase()!=mLists.get(elem.name).lName) elem.name='';	//no longer a valid list
	if (elem.name) {	// a selected list
    elem.className='address valid';
  } else if (!address) {
    elem.className='address empty';
  } else if (re.test(address)) {
    elem.className='address valid';
  } else {
		let found=false;
		mLists.forEach((list, id) => {
			if (address.toLocaleLowerCase()==list.lName) {
				found=true; 
				elem.name=list.id;	//save id of last found list
			}
		});
		if (found) {
			elem.className='address valid';
		} else {
			elem.className='address invalid';
			elem.name='';
		}
	}
  let i=document.getElementsByClassName('address invalid').length;
  let v=document.getElementsByClassName('address valid').length;
  if (i || !v) {
    document.getElementById('addressOK').disabled=true;
		allValid=false;
  } else {
    document.getElementById('addressOK').disabled=false;
		allValid=true;
	}
}

async function okAndInput(ev) {
  if (ev.repeat) {
//debug('key repeated');
    return;
  }
	ev.stopPropagation();
	if (ev.type == "keydown") {
    let sel=document.getElementById('results');
    if (ev.key == "Enter") {
      if (sel) sel.parentNode.removeChild(sel);
      if (ev.target.value) {
        newInput(ev.target);
        validate(ev.target);
      } else if (ev.ctrlKey) {
				if (allValid) send();
			}
    } else if (ev.key=='ArrowDown' || ev.key=='Tab') {
//debug('key down');
      if (sel) {
        sel.focus();
        sel.firstChild.selected=true;
        ev.preventDefault();  //else sel scrolls
      }
    } else if (ev.key == "Escape") {
//debug('cancel (Escape)');
			removeWin();
    }
	}

}

async function send() {
debug('sending messages wid='+wid);
  let sel=document.getElementById('results');
  if (sel) sel.parentNode.removeChild(sel);	//remove search resultsbox if still visible

  let [ acct, iden ]=document.getElementById("accountsel").value.split('|');
debug('Account: '+acct+' '+iden);
  let addresses=[];
  let addr=document.getElementById("address");
  while (addr) {
    let to=addr.firstChild;
    let email=to.nextSibling;
debug('addr: '+to.value+' '+email.value+' '+email.name);
		if (email.name) {
			let list=mLists.get(email.name);
			if (!list.isCB) {
				let contacts=await messenger.mailingLists.listMembers(list.id);
debug('tb contacts: '+JSON.stringify(contacts));
				contacts.forEach(contact=>{
					let email=contact.properties.PrimaryEmail;
					if (email) {
						if (contact.properties.DisplayName)
							email='"'+contact.properties.DisplayName+'" <'+email+'>';
						addresses.push({to: to.value, email: email});
					}
				});
			} else {
        if (cardbook_messaging) {
          let emails=await messenger.runtime.sendMessage(
                'cardbook@vigneau.philippe', {query: 'lists', id: list.id});
          emails.forEach(contact=>{
            email=contact.fn?'"'+contact.fn+'" <'+contact.email+'>':contact.email;
            addresses.push({to: to.value, email: email});
          });
        } else {
          let emails=await messenger.smr.cb_list(list.id);
debug('cb contacts: '+JSON.stringify(emails));
          emails.forEach(email=>{ addresses.push({to: to.value, email: email}); });
        }
			}
		} else {
			if (email.value) addresses.push({to: to.value, email: email.value});
		}
    addr=addr.nextSibling;
  }
  if (!addresses.length || !msgs.length) {
    debug('no addresses or no messages');
    return;
  }
  addresses = [...new Set(addresses)];  //remove duplicates
debug(JSON.stringify(addresses));
//return;	//debug

  msgCount=msgs.length;
  msgs.forEach(msg=>{
debug('msg: '+msg.subject)
    let tr=document.getElementById('msg_'+msg.id);
    let tdpb=tr.firstChild.nextSibling.nextSibling;
    if (msg.hasOwnProperty('state')) {  // its a resend
      if (!msg.state) {   // message was already successfull sent
        //pb.innerHTML='';
        if (!doneText) doneText=messenger.i18n.getMessage('done');
        tdpb.firstChild.firstChild.textContent=doneText; //bereits verschickt
        tdpb.firstChild.firstChild.className='textonly';
        msg.sending=false;
        msgCount--;
      } else if (msg.allowResend) {
        tr.style.color='black';
        msg.sending=true;
      }
      tdpb.firstChild.classList.remove('hide');
    } else {  //first send
      msg.sending=true;
      let pbd=document.createElement('div');
      pbd.className='pb';
      let pbs=document.createElement('span');
      pbs.id='pb_'+tr.id.substr(4);
      tr.firstChild.className='abort';
      pbs.textContent='...';
      let pb=document.createElement('progress');
      pbd.appendChild(pb);
      pbd.appendChild(pbs);
      tdpb.appendChild(pbd);
    }
  });

  let copy=document.getElementById("copy").checked;
	prefs.copytosent=copy;
debug('copy='+copy);
	prefs.identities[origAcctId]=acct+'|'+iden;
  await messenger.storage.local.set(prefs);

  sendOk=true;
  allowResend=false;

  messenger.smr.redirect(msgs, addresses, 
    {accountId: acct, identityId: iden, copy2sent: copy }, wid, prefs);
  sending=true;
debug('send done');
  document.getElementById("addressOK").disabled=true;  //disable send button
  let inps=document.getElementsByTagName('input');
  for (let inp of inps) if (inp.type=='text') inp.disabled=true;  //disable all input fields
  
  document.getElementsByTagName('body')[0].scrollIntoView(
    { block: 'start', inline: 'nearest', behavior: 'smooth'} );
}

async function cancel(e) {
debug('cancel clicked');
  if (sending) {
    msgs.forEach(msg=>{ 
      if (msg.sending) {
debug('abort '+msg.id+' '+msg.subject);
        messenger.smr.abort(wid, Number(msg.id));
      }
    });
  } else {  //its close
		removeWin();
  }
}

function removeMsg(ev) {
  let tr=ev.target.parentNode;
  let msgId=tr.id.substr(4);
  if (!sending) {
debug('remove message '+msgId);
    let msgInd=msgs.findIndex(msg=>msg.id==msgId);
    let msg=msgs[msgInd];
    msgs.splice(msgInd, 1);
    tr.parentNode.removeChild(tr);
    if (!msg.hasOwnProperty('state') || msg.state) msgCount--;
    if (!msgCount) cancel();
  } else {
debug('abort message '+msgId);
    messenger.smr.abort(wid, Number(msgId));
  }
}

async function openAB() {
debug('openAB: cb_exists returns '+await messenger.smr.cb_exists());
  if (cardbook) {
    if (cardbook_messaging) {
			messenger.runtime.sendMessage(
          'cardbook@vigneau.philippe', {query: 'openBook'});
    } else {
      messenger.smr.cb_open();
    }
	} else
		messenger.addressBooks.openUI();
}

let listener=function(data) {
debug('onMailSent fired: '+JSON.stringify(data));
  if (data.type=='copied') {  //only on test
    let pbs=document.getElementById('pb_'+data.msgid);
    let size=(Number(data.size)/1000./1000.).toFixed(2);
    size=size+'MB';
    pbs.textContent=size;
  } else if (data.type=='started') {
    let pbs=document.getElementById('pb_'+data.msgid);
    let size=(Number(data.size)/1000./1000.).toFixed(2);
    size=size+'MB';
    pbs.textContent=size;
  } else if (data.type=='finished' || data.type=='aborted') {
    let msg=msgs.find(msg=>msg.id==data.msgid);
    msg.sending=false;
    msg.state=data.state;
    msg.allowResend=data.allowResend;
    let tr=document.getElementById('msg_'+data.msgid);
    tr.firstChild.nextSibling.nextSibling.firstChild.classList.add('hide');
    tr.firstChild.removeEventListener('click', removeMsg);
    if (data.state==0) {
      tr.style.color='green';
      tr.firstChild.className='ok';
      tr.getElementsByTagName('progress')[0].remove();  //remove progressbar
    } else {
      sendOk=false;
      tr.style.color='red';
      tr.firstChild.className='failed';
      if (data.allowResend) {
        allowResend=true;
          // with NS_ERROR_SENDING_RCPT_COMMAND (status 550)or
          // with NS_ERROR_SENDING_MESSAGE, web.de problem
debug('Allow editing recipient address');
      }
    }
    msgCount--;
    if (!msgCount) {
      sending=false;
debug('no more messages, allowResend='+allowResend);
      if (allowResend) {
        document.getElementById("addressOK").disabled=false;  //reenable send button
        let inps=document.getElementsByTagName('input');
        for (let inp of inps) if (inp.type=='text') inp.disabled=false;  //reenable all input fields
        msgCount=msgs.length; //reinitialize msgCount
        msgs.forEach(msg=>{
          if (!msg.state) msgCount--;
          let tr=document.getElementById('msg_'+msg.id);
          let td=tr.firstChild;
//          td.className='remove';
          td.addEventListener('click', removeMsg);
          td.classList.add('pointer');
//          if (!msg.state) tr.classList.add('done');
        });
      }
      document.getElementById("addressCANCEL").value=messenger.i18n.getMessage('close');
      if (sendOk && prefs.closeonsuccess)
        setTimeout(()=>{ removeWin(); }, prefs.delay*1000);
    }
  }
}

async function load() {
  wid=(await messenger.windows.getCurrent()).id;
  prefs=await messenger.storage.local.get({debug: false, delay: 2, size: 0, identities: {}, changefrom: {}, copytosent: false, closeonsuccess: true});
    //dont use storage.local.get() (without arg), see https://thunderbird.topicbox.com/groups/addons/T46e96308f41c0de1
debug('load: wid='+wid+' prefs='+JSON.stringify(prefs));
debug('  allowResend='+allowResend);

  if (messenger.smr.onMailSent.hasListener(listener)) {
debug('we already have a listener');
  }
  messenger.smr.onMailSent.addListener(listener, wid);

	document.getElementById("addressCANCEL").addEventListener('click', cancel);
	document.getElementById("addressOK").addEventListener('click', send);
	let email=document.getElementById("email");
	email.addEventListener('keydown', okAndInput);
	email.addEventListener('drop', drop);
	email.addEventListener('input', search);
	setTimeout(()=>{ email.focus();	debug('focus now '+document.activeElement.tagName); }, 500);  //does not work in TB88
	document.getElementById("ab").addEventListener('click', openAB);
	document.getElementById("body").addEventListener('keydown', bodykey);
	document.getElementById("accountsel").addEventListener('change', accountchange);
	document.getElementById("changefrom").addEventListener('change', togglechangefrom);
	document.getElementById("closeonsuccess").addEventListener('change', togglecloseonsuccess);
	document.getElementById("delay").addEventListener('change', changedelay);
	document.getElementById("debug").addEventListener('change', toggledebug);

	msgs = await messenger.runtime.sendMessage({action: "requestData", prefs: prefs});
  msgCount=msgs.length;
  let mails=document.getElementById("mails");
  let tbody=mails.firstChild;
  if (tbody.tagName!='tbody') tbody=tbody.nextSibling;
	msgs.forEach(msg=>{ 
    origAcctId=msg.folder.accountId; //use account from last mail
        // TODO: accounts may be different if mails come from a virtual folder
    msg.sending=false;
    let d=new Date(msg.date);
    let date=d.toLocaleString();
    let tr=document.createElement('tr');
    tr.id="msg_"+msg.id;
    let td=document.createElement('td');
    td.textContent=' ';
    td.className="remove";
    td.addEventListener('click', removeMsg);
    tr.appendChild(td);
    td=document.createElement('td');
    td.textContent=msg.subject;
    tr.appendChild(td);
    td=document.createElement('td');  //progressbar
    //td.className='pb';
    tr.appendChild(td);
    td=document.createElement('td');
    td.textContent=msg.author;
    tr.appendChild(td);
    td=document.createElement('td');
    td.textContent=date;
    tr.appendChild(td);
    tbody.appendChild(tr);
  });


  let ae=document.getElementById('accountsel');
  let accounts;
  try {
    accounts=await messenger.accounts.list();	//array of MailAccount
  } catch(e) {
console.log('SMR: %-sign in foldernames problem, see bug 1684327');
    const msg='<div style="color: red;"><div style="margin: 2em;">Bitte entfernen sie alle %-Zeichen aus Ordnernamen!<br/>\
Es gibt einen Fehler in Thunderbird, der die Ausführung dieses Add-ons verhindert.<br/>Siehe Bug 1684327</div>\
<div style="margin: 2em;">Please remove any %-signs from foldernames!<br/>\
There is a bug in Thunderbird which prevents this add-on from running.<br/>See Bug 1684327</div></div>';
    const parser = new DOMParser();
    const parsed = parser.parseFromString(msg, 'text/html');
    const tags = parsed.getElementsByTagName('body');
    document.body=tags[0];
    return;
  }

/*
	let defAcct=origAcctId;
  let defIden=await messenger.accounts.getDefaultIdentity(defAcct);
  if (defIden) defIden=defIden.id;
  else {    //no default identity for account
debug(defAcct+': no default identity');
    let acct=await messenger.accounts.get(defAcct);
    let idens=acct.identities;
    if (idens.length) {
debug(defAcct+': use first identity');
      defIden=idens[0].id;  // use first identity
    } else {  // no identities, get identity from default account
debug(defAcct+': no identities');
      defAcct=await messenger.accounts.getDefault();
      if (!defAcct) // if no default account, use first account with identities
        accounts.some(acct=>{ if (acct.identities.length) { defAcct=acct; return true;} });
      defIden=defAcct.identities[0].id;  // use first (=default) identity
      defAcct=defAcct.id;
//debug('using '+defAcct+' '+defIden);
    }
  }
debug('using '+defAcct+' '+defIden);
*/
	let defAcctId, defIdenId;
	let pref=prefs.identities[origAcctId];
	if (pref) {
		let [ acctId, idenId ]=pref.split('|');
debug('from prefs '+acctId+' '+idenId);
//todo: check if acct and iden exists
		let acct=accounts.filter(acct=>acct.id==acctId)[0];
		let iden;
		if (acct) { //ok, account is valid
			iden=acct.identities.filter(iden=>iden.id==idenId)[0];
			if (!iden) {	//identity no longer valid (probably deleted), use default (or first) identity
debug('identity from prefs not valid, use default or first identity');
				iden=acct.identities[0];
			}
			defAcctId=acct.id;
			defIdenId=iden.id;
debug('use from prefs '+defAcctId+' '+defIdenId);
		}
else debug('account from prefs not valid');
	}
	if (!defAcctId) {	//not in prefs or invalid in prefs
		let acct=accounts.filter(acct=>acct.id==origAcctId)[0];
		let iden=acct.identities[0];
		if (iden)	{// is the default identity or at least the first identity
debug('Default Identity: '+iden.id+' in '+iden.accountId);
			defAcctId=acct.id;
			defIdenId=iden.id;
debug('Use Identity: '+defIdenId+' in '+defAcctId);
		} else {	//no identity e.g. local folders
debug('no identity for '+origAcctId);
			for (let i=0; i<accounts.length; i++) {	//find first account with identities
				if (accounts[i].identities.length) {
					defAcctId=accounts[0].id;
					defIdenId=accounts[i].identities[0].id;
debug('first usable acct/iden');
					break;
				}
			}
		}
	}
debug('using '+defAcctId+' '+defIdenId);

  let border=false;
  accounts.forEach(account=>{
    if (account.identities.length) {  //length==0 for local folders
      let bold=true;
      let o;
      account.identities.forEach(identity=>{
        o=document.createElement('option');
        o.value=account.id+'|'+identity.id;
        if (account.id==defAcctId && identity.id==defIdenId) {
          o.selected=true;
					let cf=document.getElementById('changefrom');
					let cfb=document.getElementById('changefrombox');
					cf.value=o.value;
					if (prefs.changefrom[o.value]) {
						cfb.style.display='block';
						cf.checked=true;
					}
				}

//        let a=identity.name+' &lt;'+identity.email+'&gt; ';
        let a=identity.name+' <'+identity.email+'> ';
        if (identity.label) a+='('+identity.label+') ';
//        a+='<span class="acct">'+account.name+'</span>';
        a+=account.name;
//        o.innerHTML=a;                  
        o.textContent=a;                  
        if (bold) {
          o.className='acct';
          if (!border && account.identities.length>1) o.classList.add('bt'); //border-top
        }
        bold=false;
        border=false;
        ae.appendChild(o);
      });
      if (account.identities.length>1) {
        o.classList.add('bb'); //border-bottom
        border=true;
      }
    }
  });

	document.getElementById("copy").checked=prefs.copytosent
	document.getElementById("closeonsuccess").checked=prefs.closeonsuccess
	document.getElementById('delay').value=prefs.delay;
	document.getElementById('debug').checked=prefs.debug;

	let body=document.getElementById("body");
	let size=prefs.size;
	if (!size) size=12;
	prefs.size=12;
	body.style.fontSize = size+"px";
	body.style.display = "block";

// communication with cardbook, cardbook needs to use NotifyTools
	let have_cardbook=0;
  cardbook_messaging=false;
  cardbook=0;
	try {
		let cbei=await messenger.management.get('cardbook@vigneau.philippe');
debug('cardbook version '+cbei.version);	//70.9
		let [v, major, minor]=cbei.version.match(/^(\d+)\.(\d+)/);
		if (major<70 || major==70 && minor<=9)
			have_cardbook=1;	//no api or buggy api
		else
			have_cardbook=2;	//api ok
	} catch(e) {
debug('cardbook not installed');
	}

  if (have_cardbook>=2) try {
    let cb_apiVersion=await messenger.runtime.sendMessage(
          'cardbook@vigneau.philippe', {query: 'version'});
      //returns {version: API_VERSION, exclusive: exclusive}
debug('cardbook api version '+JSON.stringify(cb_apiVersion));
    cardbook=cb_apiVersion.exclusive?1:2;
    cardbook_messaging=true;
    let cb_lists=await messenger.runtime.sendMessage(
          'cardbook@vigneau.philippe', {query: 'lists'});
debug('cardbook api lists: '+JSON.stringify(cb_lists));
    for (let list of cb_lists) {
			let emails=await messenger.runtime.sendMessage('cardbook@vigneau.philippe',
																		{query: 'lists', id: list.id});
debug('cardbook api list: '+list.name+' '+JSON.stringify(emails));
      mLists.set(list.id, {name: list.name, lName: list.name.toLocaleLowerCase(),
              isCB: true, id: list.id,
              bcolor: list.bcolor, fcolor: list.fcolor});
    };
debug('cardBook api 0=not available, 1=yes, 2=also use TB addressbook: '+cardbook);
  } catch(e) {
debug('cardbook api throws '+e);
		have_cardbook=1;	//fall back to old usage of cardbook
		cardbook_messaging=false;
  }
  else if (have_cardbook==1) debug("Don't use buggy cardbook api");

  if (have_cardbook && !cardbook_messaging) { //no messaging
    cardbook=await messenger.smr.cb_exists();	//0: no cardbook, 1: only cardbook, 2: cardbook and TB
debug('internal cardBook: 0=not found, 1=available, 2=also use TB addressbook: '+cardbook);

    if (cardbook) {	// get cardbooks mailLists
      let cb_lists=await messenger.smr.cb_list('');
debug('cb_lists: '+JSON.stringify(cb_lists));
      cb_lists.forEach(list=>{
        mLists.set(list.id, {name: list.name, lName: list.name.toLocaleLowerCase(),
                              isCB: true, id: list.id, bcolor: list.bcolor, fcolor: list.fcolor});
      });
    }
  }
//if (!cardbook) console.log('SMR: cardbook not installed');

	if (!cardbook || cardbook>1) {	// get TB's mailLists
		let abs=await messenger.addressBooks.list();
		for (const ab of abs)	{//ab.id, ab.name
//debug('ab: '+JSON.stringify(ab));
			let mls=await messenger.mailingLists.list(ab.id);
			for (const ml of mls)	{//ml.id, ml.parentId, ml.name, ml.nickName, ml.description
				ml.lName=ml.name.toLocaleLowerCase();
				ml.abName=ab.name;
				ml.isCB=false;
        ml.bcolor='';
        ml.fcolor='';
				mLists.set(ml.id, ml);
//debug('ml: '+JSON.stringify(ml));
			};
		};
	}
//debug('lists: '+mLists.size+' '+JSON.stringify(Array.from(mLists.entries())));
}

function accountchange(ev) {
  let acct=ev.target.value;
debug('account now '+acct);
  let cf=document.getElementById('changefrom');
  let cfb=document.getElementById('changefrombox');
  cf.value=acct;
	if (prefs.changefrom[acct]) {
		cfb.style.display='block';
		cf.checked=true;
	} else {
		cfb.style.display='none';
		cf.checked=false;
	}
}
function togglechangefrom(ev) {
	prefs.changefrom[ev.target.value]=ev.target.checked;
debug('changefrom for '+ev.target.value+' now '+(prefs.changefrom[ev.target.value]?'on':'off'));
debug(JSON.stringify(prefs));
  messenger.storage.local.set(prefs);
}


async function search(ev) {
  let sel=document.getElementById('results');
  validate(ev.target);
	let sv=ev.target.value;
  if (sv.length<2) {
    if (sel) sel.style.display='none';
    return;
  }
	let addresses=[];
	let lists=[];
	let re=new RegExp(sv, 'i');
	for (const list of mLists.values()) {
		if (list.lName.match(re)) {
			lists.push({list: list.name, id: list.id, bcolor: list.bcolor, fcolor: list.fcolor});
		}
	};

	if (cardbook)	{	//0: no cardbook, 1: only cardbook, 2: cardbook and TB
    if (cardbook_messaging) {
      let contacts=await messenger.runtime.sendMessage(
            'cardbook@vigneau.philippe', {query: 'contacts', search: sv/*+' @'*/});
//debug('cardbook contacts: '+JSON.stringify(contacts));
      for (let contact of contacts) {
        for (let l = 0; l < contact.email.length; l++) {
          addresses.push({email: '"'+contact.fn+'" <'+contact.email[l][0][0]+'>',
            bcolor: contact.bcolor, fcolor: contact.fcolor});
        }
      }
    } else {
      addresses=await messenger.smr.cb_search(sv/*+' @'*/);
    }
	}
	if (!cardbook || cardbook>1) {
		let nodes=await messenger.contacts.quickSearch(null, '"'+sv+'" @');
/*
debug('search: '+sv);
		let nodes=await messenger.contacts.quickSearch(null, sv);
*/
		nodes.forEach(node=>{
//debug('contact: '+JSON.stringify(node));
			if (node.properties.PrimaryEmail)
				addresses.push({email: node.properties.DisplayName?
					'"'+node.properties.DisplayName+'" <'+node.properties.PrimaryEmail+'>':
					node.properties.PrimaryEmail} );
			if (node.properties.SecondEmail)
				addresses.push({email: node.properties.DisplayName?
					'"'+node.properties.DisplayName+'" <'+node.properties.SecondEmail+'>':
					node.properties.SecondEmail});
		});
	}
  addresses = [...new Set(addresses)];  //remove duplicates
	addresses=lists.concat(addresses);

//debug('found '+addresses.length);
  if (addresses.length && addresses.length<=20) {
    if (sel) {
      while (sel.firstChild) sel.removeChild(sel.lastChild);
      sel.style.display='block';
    } else {
      sel=document.createElement('select');
      sel.id='results';
      sel.multiple=true;
      sel.autocomplete='off';
      sel.addEventListener('keyup', selectitem);
      sel.addEventListener('keydown', selectitem);
      sel.addEventListener('click', selectitem);
    }
    sel.size=addresses.length<=5?addresses.length:5;
    addresses.forEach(address =>{
      let opt=document.createElement('option');
			if (address.email) {            //email
				opt.text=address.email;
				opt.value='|'+address.email;
			} else {                            //list
				opt.text=address.list;
				opt.value=address.id+'|'+address.list;
			}
      if (address.bcolor) {
        opt.style.backgroundColor=address.bcolor;
        opt.style.color=address.fcolor;
      }
      sel.appendChild(opt);
    });
    ev.target.parentNode.parentNode.insertBefore(sel, ev.target.parentNode.nextSibling); //appends if no nextSibling
/*
    let offset=document.getElementById("address").offsetTop;
//debug('offset='+offset);
//debug('div.clientHeight='+sel.parentNode.clientHeight+
//'-(input.offsetTop='+sel.previousSibling.offsetTop+
//'+input.offsetHeight='+sel.previousSibling.offsetHeight+
//'+sel.offsetHeight='+sel.offsetHeight+')');
    sel.parentNode.scrollTop = 
      (sel.previousSibling.offsetTop-offset + sel.previousSibling.offsetHeight+sel.offsetHeight)
      - sel.parentNode.clientHeight;
*/
    sel.scrollIntoView(false);
  } else {
    let sel=document.getElementById('results');
    if (sel) sel.style.display='none';
  }
}

function selectitem(ev) {
  if (ev.type == "keydown" && ev.key=='Tab'
          || ev.type == "keyup" && (ev.key == "Enter" || ev.key==" " )
          || ev.type == 'click') {
		ev.stopPropagation();
    ev.preventDefault();
    let sel=document.getElementById('results');
    let input=sel.previousSibling.firstChild.nextSibling;
    sel.parentNode.removeChild(sel);
		let data=ev.target.value.split('|');
    input.name=data.shift();	//list id or ''
    input.value=data.join('|');
//debug('selected: list='+input.name+' value='+input.value);
    validate(input);
    input.focus();
    newInput(input);
  }
}
function drop(ev) {
  let sel=document.getElementById('results');
  if (sel) sel.style.display='none';
  let address = ev.dataTransfer.getData("text");
  debug('dropped '+address);
  if (!ev.target.value) //else its a replace
    newInput(ev.target);
  ev.target.value=address;
  validate(ev.target);
  ev.preventDefault();
}
function newInput(elem) {
//debug('generate new input field');
  let addr=elem.parentNode; //flex container
	let to=addr.firstChild.value;
  let na=addr.nextSibling;
//debug('newInput next is '+ni);
  if (!na) {
    na=addr.cloneNode(true);
    na.removeAttribute('id');
		na.firstChild.value=to;
    let ni=na.firstChild.nextSibling;
      ni.removeAttribute('id');
      ni.value='';
			ni.name='';
      ni.className='empty';
      ni.addEventListener('keydown', okAndInput);
      ni.addEventListener('drop', drop);
      ni.addEventListener('input', search);
    addr.parentNode.appendChild(na);
    ni.focus();
  }
  document.getElementsByTagName('body')[0].scrollIntoView(false);
}

let hidden='';
async function bodykey(ev) {
  if (ev.repeat) {
//debug('key repeated');
    return;
  }
	if (ev.type == "keydown") {
		let resize=false;
    if (ev.key == "+" && ev.ctrlKey) {
			prefs.size++;
			resize=true;
    } else if (ev.key == "-" && ev.ctrlKey) {
			prefs.size--;
			resize=true;
    } else if (ev.key == "0" && ev.ctrlKey) {
			prefs.size=12;
			resize=true;
    } else if (ev.key == "Enter" && ev.ctrlKey) {
			if (allValid) send();
    } else if (ev.key == "s" && !hidden) {
			hidden='s';
    } else if (ev.key == "m" && hidden=='s') {
			hidden='m';
    } else if (ev.key == "r" && hidden=='m') {
			hidden='';
			document.getElementById('debugbox').style.display='inline-block';
    } else if (ev.key == "r" && !hidden) {
			hidden='r';
    } else if (ev.key == "w" && hidden=='r') {
			hidden='w';
    } else if (ev.key == "f" && hidden=='w') {
			hidden='';
			document.getElementById('changefrombox').style.display='block';
		} else {
			hidden='';
		}
		if (resize) {
			let body=document.getElementById("body");
			let size=prefs.size;
			body.style.fontSize = size+"px";
			hidden='';
		}
	}
}
function toggledebug(ev) {
	prefs.debug=ev.target.checked;
console.log('SMR: debug now '+(prefs.debug?'on':'off'));
  messenger.storage.local.set(prefs);
}
function togglecloseonsuccess(ev) {
	prefs.closeonsuccess=ev.target.checked;
console.log('SMR: closeonsuccess now '+(prefs.closeonsuccess?'on':'off'));
  messenger.storage.local.set(prefs);
}
function changedelay(ev) {
	prefs.delay=ev.target.value;
console.log('SMR: delay now '+prefs.delay);
  messenger.storage.local.set(prefs);
}

async function removeWin() {
	let win = await messenger.windows.getCurrent();
	let wInfo=await messenger.windows.get(win.id);
	prefs.top=wInfo.top;
	prefs.left=wInfo.left;
	//prefs.height=wInfo.height;
	prefs.width=wInfo.width;
  await messenger.storage.local.set(prefs);
	debug('positioned window now at '+prefs.left+'x'+prefs.top);
	debug('sized window now '+prefs.width);	//+'x'+prefs.height);
	debug('font size now '+prefs.size);

	await messenger.windows.remove(win.id);	
}

document.addEventListener('DOMContentLoaded', load, { once: true });
// window close is recognized by unregister of onMailSent

let debugcache='';
function debug(txt, force) {
	if (force || prefs) {
		if (force || prefs.debug) {
			if (debugcache) console.log(debugcache); debugcache='';
			console.log('SMR: '+txt);
		}
	} else {
		debugcache+='SMR: '+txt+'\n';
	}
}
